<template>
  <AppModal
    name-modal="modal-begin-chat"
    :width-modal="520"
    :visible="visible"
    @before-close="$emit('before-close'); $ym('chat_guest_modal_closed')"
    init-class="modalBeginChat">
    <!-- TODO: почти такая же фома есть в АppСhatNoLogin [REFACTORING] -->
    <div
      slot="body"
      class="beginChat">
      <div class="beginChat-heading">
        <div class="heading">Начать чат с продавцом</div>
      </div>
      <div class="beginChat-form">
        <div class="form">
          <span class="beginChat-notes"><sup class="__red">*</sup> Обязательно</span>
          <div class="form-item">
            <AppInputComposite
              v-model="name"
              :class="{ '-invalid': validation.hasError('name')}">
              <template #label>Как к вам обращаться <sup class="__red">*</sup></template>
            </AppInputComposite>
            <div
              v-if="validation.hasError('name')"
              class="input-message-error _left">
              {{ validation.firstError('name') }}
            </div>
          </div>

          <div class="form-item">
            <AppInputComposite
              v-model="email"
              :class="{ '-invalid': issetErrors.email || validation.firstError('email')}">
              <template #label>Ваша почта</template>
            </AppInputComposite>
            <div
              v-if="issetErrors.email || validation.hasError('email')"
              class="input-message-error _left">
              {{ issetErrors.email || validation.firstError('email') }}
              <span
                v-if="issetErrors.email">
                <a
                  class="link"
                  href="#"
                  @click.prevent="isVisible = false; showAuthModal();">Авторизуйтесь
                </a>
                или укажите другой e-mail.
              </span>
            </div>
          </div>

          <div class="form-item">
            <AppInputPhone
              v-model="phone"
              :options="{ validationRule: { isRequired: false } }"
              @has-error="inputErrors.phone = $event"/>
            <div
              v-if="issetErrors.phone"
              class="input-message-error _left">
              {{ issetErrors.phone }}
              <span v-if="issetErrors.phone">
                <a
                  class="link"
                  @click.prevent="isVisible = false; showAuthModal();">Авторизуйтесь</a>
                или укажите другой номер телефона.
              </span>
            </div>
          </div>


          <div class="form-item">
            <div class="beginChat-notes">
              Нажимая на кнопку «Начать чат» вы даете согласие на
              <flink
                target="_blank"
                domain="main"
                href="/about-us/agreement"
                class="link">
                обработку персональных данных
              </flink>
            </div>
          </div>

          <div
            v-if="apiError"
            class="form-item">
            <div class="input-message-error">
              Временная ошибка, пожалуйста, повторите запрос позднее
            </div>
          </div>

          <div class="form-item">
            <AppButton
              @click.native="send(); $ym('chat_seller_begin_chat')"
              :disabled="submitDisabled">
              <span
                slot="button-item"
                class="button-item">
                Начать чат
              </span>
            </AppButton>
          </div>
        </div>
      </div>
    </div>
  </AppModal>
</template>

<script>
import { createNamespacedHelpers } from 'vuex';

import {
  SHOW_BEGIN_CHAT_MODAL,
  HIDE_BEGIN_CHAT_MODAL,
} from '~/assets/js/store/actionManager/mutation-types';

import BeginChatMixin from '~/assets/js/mixins/redesign/begin-chat';
import AppModal from '~/components/redesign/app-modals/app-modal';
import AppButton from '~/components/redesign/app-buttons/app-button';
import AppInputPhone from '~/components/redesign/app-input/app-input-phone';
import AppInputComposite from '~/components/redesign/app-input/app-input-composite';
import Modals from '~/assets/js/mixins/redesign/modals';

const STORE_ACTION_MANAGER = createNamespacedHelpers('actionManager');

export default {
  name: 'AppModalBeginChat',
  components: {
    AppInputComposite,
    AppModal,
    AppButton,
    AppInputPhone,
  },
  mixins: [Modals, BeginChatMixin],
  computed: {
    ...STORE_ACTION_MANAGER.mapState({
      shown: 'beginChatModal',
    }),
  },
  methods: {
    ...STORE_ACTION_MANAGER.mapMutations({
      show: SHOW_BEGIN_CHAT_MODAL,
      hide: HIDE_BEGIN_CHAT_MODAL,
    }),
  },
};
</script>

<style lang="postcss">
  .modalBeginChat {
    .appModal-header {
      padding: 0;
      height: auto;
      border: none;
    }

    @media screen and (max-width: 980px) {
      min-height: 100vh;

      .appModal-body {
        max-height: 100vh;
      }
    }

    .input-message-error {
      text-align: center;
      display: block;
      &._left {
        text-align: left;
      }
    }
  }

  .beginChat {
    &-heading {
      display: block;
      padding: 2rem 1.25rem 1.25rem;
      text-align: center;
    }

    &-notes {
      display: block;
      font-size: 0.75rem;
    }

    &-form {
      display: block;
      padding: 0 1.25rem 1.25rem 1.25rem;

      .form {
        display: block;
        margin: 0 auto;
        width: 100%;
        max-width: 21.25rem;

        & > .beginChat-notes {
          display: block;
          margin-bottom: .5rem;
        }

        .invalid {
          box-shadow: inset 0 0 0 1px var(--form-error-border-color);
        }

        &-item {
          display: flex;
          flex-direction: column;
          justify-content: space-between;
          font-size: 0.75rem;
          padding-bottom: 1.25rem;


          .inputComposite {
            width: 100%;
          }

          .button {
            width: 100%;
            height: var(--btn-height-large);
          }

          .link {
            white-space: nowrap;
          }
        }
      }
    }

    @media screen and (max-width: 1200px) and (min-width: 981px) {
      &-heading {
        padding-top: 2.5rem;
      }

      &-form {
        .form-item {
          font-size: 0.875rem;
          .button {
            margin-top: 0.5rem;
          }
        }
      }
    }

    @media screen and (max-width: 980px) {
      display: flex;
      flex-direction: column;
      justify-content: center;
      flex-grow: 1;
      height: 100%;

      &-heading {
        padding-top: 2.5rem;
      }

      &-form {
        .form-item {
          font-size: 0.875rem;
          .button {
            margin-top: 0.5rem;
            font-size: 1rem;
          }
        }
      }
    }
  }
</style>
